dnl acinclude.m4 -- various bits of this have been borrowed from the m4
dnl configuration files for KDE and GNOME

AC_DEFUN([AC_CHECK_COMPILERS],
[
  AC_ARG_ENABLE(debug,[  --enable-debug 	  creates debugging code [default=no]],
  [ 
   if test $enableval = "no"; dnl 
     then ac_use_debug_code="no"
     else ac_use_debug_code="yes"
   fi
  ], [ac_use_debug_code="no"])

  dnl Just for configure --help

  dnl this prevents stupid AC_PROG_CC from adding "-g" to the default CFLAGS
  c_flags_in=$CFLAGS

  AC_PROG_CC
  AC_PROG_CPP

  CFLAGS=$c_flags_in

  if test -z "$CFLAGS"; then 
    if test "$GCC" = "yes"; then
      if test "$ac_use_debug_code" = "yes"; then
        CFLAGS="-g $CFLAGS"
      else
        CFLAGS="-O2 $CFLAGS"
      fi
    else 
      if test "$ac_use_debug_code" = "yes"; then
        AC_CHECK_C_COMPILER_FLAG(g,
          [
            CFLAGS="-g $CFLAGS"
        ])
      else 
        AC_CHECK_C_COMPILER_FLAG(O2,
          [
            CFLAGS="-O2 $CFLAGS"
        ])
      fi
    fi
    if test "$GCC" = "yes"; then
       CFLAGS="$CFLAGS -Wall"
    fi
  fi

  PTHREAD_FLAG_C=""
  AC_CHECK_C_COMPILER_FLAG(pthread,
    [
      PTHREAD_FLAG_C="-pthread"
  ])
  AC_SUBST(PTHREAD_FLAG_C)

  dnl this prevents stupid AC_PROG_CXX from adding "-g" to the default CXXFLAGS
  cxx_flags_in=$CXXFLAGS

  AC_PROG_CXX
  AC_PROG_CXXCPP

  CXXFLAGS=$cxx_flags_in

  if test -z "$CXXFLAGS"; then 
    if test "$GXX" = "yes"; then
      if test "$ac_use_debug_code" = "yes"; then
        CXXFLAGS="-g $CXXFLAGS"
      else
        CXXFLAGS="-O2 $CXXFLAGS"
        if test -z "$LDFLAGS"; then 
          LDFLAGS="-s"
        fi
      fi
    else 
      if test "$ac_use_debug_code" = "yes"; then
        AC_CHECK_COMPILER_FLAG(g,
          [
            CXXFLAGS="-g $CXXFLAGS"
        ])
      else 
        AC_CHECK_COMPILER_FLAG(O2,
          [
            CXXFLAGS="-O2 $CXXFLAGS"
        ])
      fi
    fi

    AC_CHECK_COMPILER_FLAG(fexceptions,
      [
        CXXFLAGS="$CXXFLAGS -fexceptions"
    ])

    if test "$GXX" = "yes"; then
       CXXFLAGS="$CXXFLAGS -Wall"
    fi
  fi

  AC_CHECK_COMPILER_FLAG(std=c++11,
    [
      CXXFLAGS="$CXXFLAGS -std=c++11"
    ],
    [
    AC_CHECK_COMPILER_FLAG(std=c++0x,
      [
        CXXFLAGS="$CXXFLAGS -std=c++0x"
    ])
  ])

  PTHREAD_FLAG_CXX=""
  AC_CHECK_COMPILER_FLAG(pthread,
    [
      PTHREAD_FLAG_CXX="-pthread"
  ])
  AC_SUBST(PTHREAD_FLAG_CXX)
])

AC_DEFUN([AC_CHECK_COMPILER_FLAG],
[
AC_MSG_CHECKING(whether $CXX supports -$1)
flag_cache=`echo $1 | sed 'y%.=/+-%___p_%'`
AC_CACHE_VAL(ac_cv_prog_cxx_$flag_cache,
[
echo 'int main() { return 0; }' >conftest.cc
eval "ac_cv_prog_cxx_$flag_cache=no"
if test -z "`$CXX -$1 -c conftest.cc 2>&1`"; then
  if test -z "`$CXX -$1 -o conftest conftest.o 2>&1`"; then
    eval "ac_cv_prog_cxx_$flag_cache=yes"
  fi
fi
rm -f conftest*
])
if eval "test \"`echo '$ac_cv_prog_cxx_'$flag_cache`\" = yes"; then
 AC_MSG_RESULT(yes)
 :
 $2
else
 AC_MSG_RESULT(no)
 :
 $3
fi
])

AC_DEFUN([AC_CHECK_C_COMPILER_FLAG],
[
AC_MSG_CHECKING(whether $CC supports -$1)
flag_cache=`echo $1 | sed 'y%.=/+-%___p_%'`
AC_CACHE_VAL(ac_cv_prog_c_$flag_cache,
[
echo 'int main(void) { return 0; }' >conftest.c
eval "ac_cv_prog_c_$flag_cache=no"
if test -z "`$CC -$1 -c conftest.c 2>&1`"; then
  if test -z "`$CC -$1 -o conftest conftest.o 2>&1`"; then
    eval "ac_cv_prog_c_$flag_cache=yes"
  fi
fi
rm -f conftest*
])
if eval "test \"`echo '$ac_cv_prog_c_'$flag_cache`\" = yes"; then
 AC_MSG_RESULT(yes)
 :
 $2
else
 AC_MSG_RESULT(no)
 :
 $3
fi
])

AC_DEFUN([AC_CLOSING_MESSAGE],
[
echo
echo "    Configuration complete."
echo
echo "    To compile, enter \`make', and then enter \`make install'"
echo "      -- \`make install' must be run as root."
echo
echo "    To reconfigure, enter \`make clean' and then run \`./configure' again."
echo
])

dnl PKG_CHECK_MODULES(GSTUFF, gtk+-2.0 >= 1.3 glib = 1.3.4, action-if, action-not)
dnl defines GSTUFF_LIBS, GSTUFF_CFLAGS, see pkg-config man page
dnl also defines GSTUFF_PKG_ERRORS on error
AC_DEFUN([PKG_CHECK_MODULES], [
  succeeded=no

  if test -z "$PKG_CONFIG"; then
    AC_PATH_PROG(PKG_CONFIG, pkg-config, no)
  fi

  if test "$PKG_CONFIG" = "no" ; then
     echo "*** The pkg-config script could not be found. Make sure it is"
     echo "*** in your path, or set the PKG_CONFIG environment variable"
     echo "*** to the full path to pkg-config."
     echo "*** Or see http://www.freedesktop.org/software/pkgconfig to get pkg-config."
  else
     PKG_CONFIG_MIN_VERSION=0.9.0
     if $PKG_CONFIG --atleast-pkgconfig-version $PKG_CONFIG_MIN_VERSION; then
        AC_MSG_CHECKING(for $2)

        if $PKG_CONFIG --exists "$2" ; then
            AC_MSG_RESULT(yes)
            succeeded=yes

            AC_MSG_CHECKING($1_CFLAGS)
            $1_CFLAGS=`$PKG_CONFIG --cflags "$2"`
            AC_MSG_RESULT($$1_CFLAGS)

            AC_MSG_CHECKING($1_LIBS)
            $1_LIBS=`$PKG_CONFIG --libs "$2"`
            AC_MSG_RESULT($$1_LIBS)
        else
            $1_CFLAGS=""
            $1_LIBS=""
            AC_MSG_RESULT([no])
        fi

        AC_SUBST($1_CFLAGS)
        AC_SUBST($1_LIBS)
     else
        echo "*** Your version of pkg-config is too old. You need version $PKG_CONFIG_MIN_VERSION or newer."
        echo "*** See http://www.freedesktop.org/software/pkgconfig"
     fi
  fi

  if test $succeeded = yes; then
     ifelse([$3], , :, [$3])
  else
     ifelse([$4], , AC_MSG_ERROR([Library requirements ($2) not met; consider adjusting the PKG_CONFIG_PATH environment variable if your libraries are in a nonstandard prefix so pkg-config can find them.]), [$4])
  fi
])

dnl PKG_CHECK_VERSION does the same as PKG_CHECK_MODULES except
dnl that it does not set *_CFLAGS and *_LIBS variables
dnl PKG_CHECK_VERSION(description, gtk+-2.0 >= 1.3 glib = 1.3.4, action-if, action-not)
AC_DEFUN([PKG_CHECK_VERSION], [
  succeeded=no

  if test -z "$PKG_CONFIG"; then
    AC_PATH_PROG(PKG_CONFIG, pkg-config, no)
  fi

  if test "$PKG_CONFIG" = "no" ; then
     echo "*** The pkg-config script could not be found. Make sure it is"
     echo "*** in your path, or set the PKG_CONFIG environment variable"
     echo "*** to the full path to pkg-config."
     echo "*** Or see http://www.freedesktop.org/software/pkgconfig to get pkg-config."
  else
     PKG_CONFIG_MIN_VERSION=0.9.0
     if $PKG_CONFIG --atleast-pkgconfig-version $PKG_CONFIG_MIN_VERSION; then
        AC_MSG_CHECKING(for $1)

        if $PKG_CONFIG --exists "$2" ; then
            AC_MSG_RESULT(yes)
            succeeded=yes
        else
            AC_MSG_RESULT([no])
        fi
     else
        echo "*** Your version of pkg-config is too old. You need version $PKG_CONFIG_MIN_VERSION or newer."
        echo "*** See http://www.freedesktop.org/software/pkgconfig"
     fi
  fi

  if test $succeeded = yes; then
     ifelse([$3], , :, [$3])
  else
     ifelse([$4], , AC_MSG_ERROR([Library requirements ($2) not met; consider adjusting the PKG_CONFIG_PATH environment variable if your libraries are in a nonstandard prefix so pkg-config can find them.]), [$4])
  fi
])

AC_DEFUN([PKG_CHECK_DBUS_GLIB], [

  PKG_CHECK_MODULES(DBUS_GLIB, dbus-glib-1 >= 0.70,
  [
    AC_DEFINE([HAVE_DBUS_GLIB], [1], [Define to 1 if you do not have gio dbus but do have dbus-glib.])
  ],
  [
    DBUS_GLIB_CFLAGS=""
    DBUS_GLIB_LIBS=""
    AC_SUBST(DBUS_GLIB_CFLAGS)
    AC_SUBST(DBUS_GLIB_LIBS)
  ])
])

AC_DEFUN([PKG_CHECK_GIO], [

  PKG_CHECK_MODULES(GIO, gio-2.0 >= 2.26.0,
  [
    AC_DEFINE([HAVE_GIO_DBUS], [1], [Define to 1 if you have the gio dbus implementation.])
    DBUS_GLIB_CFLAGS=""
    DBUS_GLIB_LIBS=""
    AC_SUBST(DBUS_GLIB_CFLAGS)
    AC_SUBST(DBUS_GLIB_LIBS)
  ],
  [ 
    PKG_CHECK_MODULES(GIO, gio-2.0 >= 2.16.0,
    [ : ],
    [
      GIO_CFLAGS=""
      GIO_LIBS=""
      AC_SUBST(GIO_CFLAGS)
      AC_SUBST(GIO_LIBS)
    ])

    PKG_CHECK_DBUS_GLIB
  ])
])

AC_DEFUN([AC_MEMORY_SLICES],
[
  AC_MSG_CHECKING(whether library is to use glib memory slices)
  AC_MSG_RESULT([ ])

  no_compat=""
  AC_ARG_WITH(glib-memory-slices-no-compat,
  [  --with-glib-memory-slices-no-compat   use glib memory slices to allocate memory on free store and do not keep compatibility with library compiled without this option [[default=no]]],
  [
    if test "x$withval" != "xno";  then
      AC_USE_GLIB_MEMORY_SLICES_NO_COMPAT="define CGU_USE_GLIB_MEMORY_SLICES_NO_COMPAT 1"
      AC_MSG_RESULT([    without keeping compatibility with the library compiled without slices: yes])
      no_compat="yes"
    else
      AC_USE_GLIB_MEMORY_SLICES_NO_COMPAT="undef CGU_USE_GLIB_MEMORY_SLICES_NO_COMPAT"
      AC_MSG_RESULT([    without keeping compatibility with the library compiled without slices: no])
    fi
  ]
  ,
  [
    AC_USE_GLIB_MEMORY_SLICES_NO_COMPAT="undef CGU_USE_GLIB_MEMORY_SLICES_NO_COMPAT"
    AC_MSG_RESULT([    without keeping compatibility with the library compiled without slices: no])
  ])
  AC_SUBST(AC_USE_GLIB_MEMORY_SLICES_NO_COMPAT)
  
  if test "x$no_compat" != "xyes";  then
    AC_ARG_WITH(glib-memory-slices-compat,
    [  --with-glib-memory-slices-compat   use glib memory slices to allocate memory on free store but keep compatibility with library compiled without this option [[default=no]]],
    [
      if test "x$withval" != "xno";  then
        AC_USE_GLIB_MEMORY_SLICES_COMPAT="define CGU_USE_GLIB_MEMORY_SLICES_COMPAT 1"
        AC_MSG_RESULT([    keeping compatibility with the library compiled without slices:         yes])
      else
        AC_USE_GLIB_MEMORY_SLICES_COMPAT="undef CGU_USE_GLIB_MEMORY_SLICES_COMPAT"
        AC_MSG_RESULT([    keeping compatibility with the library compiled without slices:         no])
      fi
    ]
    ,
    [
      AC_USE_GLIB_MEMORY_SLICES_COMPAT="undef CGU_USE_GLIB_MEMORY_SLICES_COMPAT"
      AC_MSG_RESULT([    keeping compatibility with the library compiled without slices:         no])
    ])
  else
    AC_USE_GLIB_MEMORY_SLICES_COMPAT="undef CGU_USE_GLIB_MEMORY_SLICES_COMPAT"
  fi
  
  AC_SUBST(AC_USE_GLIB_MEMORY_SLICES_COMPAT)
])

AC_DEFUN([AC_WITH_CGU_USING_DIRECTIVE],
[
  AC_MSG_CHECKING(whether library headers to incorporate Cgu using directive)

  AC_ARG_WITH(cgu-using-directive,
  [  --with-cgu-using-directive   whether library headers are to include a 'using namespace Cgu' directive [[default=no]]],
  [
    if test "x$withval" != "xno";  then
      AC_USING_NAMESPACE="using namespace Cgu;"
      AC_MSG_RESULT([yes])
    else
      AC_USING_NAMESPACE="// do not include using directive"
      AC_MSG_RESULT([no])
    fi
  ]
  ,
  [
    AC_USING_NAMESPACE="// do not include using directive"
    AC_MSG_RESULT([no])
  ])
  AC_SUBST(AC_USING_NAMESPACE)
])

AC_DEFUN([AC_WITH_AUTO_PTR],
[
  AC_MSG_CHECKING(whether to use std::auto_ptr instead of std::unique_ptr)

  AC_ARG_WITH(auto-ptr,
  [  --with-auto-ptr   use std::auto_ptr instead of std::unique_ptr [[default=no]]],
  [
    if test "x$withval" != "xno";  then
      AC_USE_AUTO_PTR="define CGU_USE_AUTO_PTR 1"
      AC_MSG_RESULT([yes])
    else
      AC_USE_AUTO_PTR="undef CGU_USE_AUTO_PTR"
      AC_MSG_RESULT([no])
    fi
  ]
  ,
  [
    AC_USE_AUTO_PTR="undef CGU_USE_AUTO_PTR"
    AC_MSG_RESULT([no])
  ])
  AC_SUBST(AC_USE_AUTO_PTR)
])

AC_DEFUN([AC_WITH_SMART_PTR_COMPARISON],
[
  AC_MSG_CHECKING([whether ==, != and < operators to be available for smart pointers and handles])

  AC_ARG_WITH(smart-ptr-comp,
  [  --without-smart-ptr-comp   no ==, != and < operators to be available for smart pointers and handles  [[default=yes]]],
  [
    if test "x$withval" != "xno";  then
      AC_USE_SMART_PTR_COMPARISON="define CGU_USE_SMART_PTR_COMPARISON 1"
      AC_MSG_RESULT([yes])
    else
      AC_USE_SMART_PTR_COMPARISON="undef CGU_USE_SMART_PTR_COMPARISON"
      AC_MSG_RESULT([no])
    fi
  ]
  ,
  [
    AC_USE_SMART_PTR_COMPARISON="define CGU_USE_SMART_PTR_COMPARISON 1"
    AC_MSG_RESULT([yes])
  ])
  AC_SUBST(AC_USE_SMART_PTR_COMPARISON)
])

AC_DEFUN([AC_CHECK_HAVE_MONOTONIC_CLOCK],
[
  AC_MSG_CHECKING(whether the system supports monotonic clocks)
  AC_CACHE_VAL(ac_cv_have_monotonic_clock,
  [
    AC_RUN_IFELSE(
    [
      AC_LANG_PROGRAM(
      [
#include <unistd.h>
      ],
      [
        if (_POSIX_MONOTONIC_CLOCK > 0
	   && _POSIX_CLOCK_SELECTION > 0)
	   return 0;

        if (_POSIX_MONOTONIC_CLOCK == -1
	   || _POSIX_CLOCK_SELECTION == -1)
	    return -1;

        if (sysconf(_SC_MONOTONIC_CLOCK) > 0
	   && sysconf(_SC_CLOCK_SELECTION) > 0)
	   return 0;

        return -1;
      ])
    ],
    [
      ac_cv_have_monotonic_clock="yes"
    ],
    [
      ac_cv_have_monotonic_clock="no"
    ],
    [
      AC_MSG_RESULT([cross-compiling: ])
      ac_cv_have_monotonic_clock="no"
    ])
  ])

  AC_MSG_RESULT([$ac_cv_have_monotonic_clock])
  if test "$ac_cv_have_monotonic_clock" = "yes" ; then
    AC_DEFINE(HAVE_MONOTONIC_CLOCK, 1, [ Define if the system supports monotonic clocks ])
  fi
])

AC_DEFUN([AC_CHECK_HAVE_SCHED_YIELD],
[
  AC_MSG_CHECKING(for sched_yield)
  AC_CACHE_VAL(ac_cv_have_sched_yield,
  [
    AC_COMPILE_IFELSE(
    [
      AC_LANG_PROGRAM([
#include <sched.h>
      ],
      [
        sched_yield();
      ])
    ],
    [
      ac_cv_have_sched_yield="yes"
    ],
    [
      ac_cv_have_sched_yield="no"
    ]
    )
  ])

  AC_MSG_RESULT([$ac_cv_have_sched_yield])
  if test "$ac_cv_have_sched_yield" = "yes" ; then
    AC_USE_SCHED_YIELD="define CGU_USE_SCHED_YIELD 1"
  else
    AC_USE_SCHED_YIELD="undef CGU_USE_SCHED_YIELD"
  fi 
  AC_SUBST(AC_USE_SCHED_YIELD)
])

AC_DEFUN([AC_CHECK_HAVE_RECURSIVE_MUTEX],
[
  AC_MSG_CHECKING(whether headers include provision for recursive mutexes)
  AC_CACHE_VAL(ac_cv_have_recursive_mutex_headers,
  [
    AC_COMPILE_IFELSE(
    [
      AC_LANG_PROGRAM([
#define _XOPEN_SOURCE 600
#include <pthread.h>
      ],
      [
        pthread_mutexattr_t attr;
        pthread_mutexattr_init(&attr);
        pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE);
        pthread_mutexattr_destroy(&attr);
      ])
    ],
    [
      ac_cv_have_recursive_mutex_headers="yes"
    ],
    [
      ac_cv_have_recursive_mutex_headers="no"
    ]
    )
  ])

  AC_MSG_RESULT([$ac_cv_have_recursive_mutex_headers])
  if test "$ac_cv_have_recursive_mutex_headers" = "yes" ; then

    AC_DEFINE(HAVE_RECURSIVE_MUTEX_HEADERS, 1, [ Define if headers include provision for recursive mutexes ])

    AC_MSG_CHECKING(whether the runtime provides working recursive mutexes)
    AC_CACHE_VAL(ac_cv_have_recursive_mutex_runtime,
    [
      lib_save=$LIBS
      echo 'int main(void) { return 0; }' >conftest.c
      cgu_pthread_flag=no
      if test -z "`$CC -pthread -c conftest.c 2>&1`"; then
        if test -z "`$CC -pthread -o conftest conftest.o 2>&1`"; then
	  cgu_pthread_flag=yes
	fi
      fi
      rm -f conftest*
      if test "$cgu_pthread_flag" = "yes" ; then
        LIBS="-pthread"
	echo -n "using -pthread: "
      else
        dnl if -pthread (and so the gcc toolchain) isn't used
	dnl then -lpthread should be OK just for a run test
        LIBS="-lpthread"
      fi        
      AC_RUN_IFELSE(
      [
        AC_LANG_PROGRAM(
      	[
#define _XOPEN_SOURCE 600
#include <pthread.h>
        ],
      	[
          pthread_mutexattr_t attr;
	  if (pthread_mutexattr_init(&attr))
    	  return -1;
  	  if (pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE)) {
    	    pthread_mutexattr_destroy(&attr);
	    return -1;
  	  }
  	  pthread_mutexattr_destroy(&attr);
  	  return 0;
      	])
      ],
      [
        ac_cv_have_recursive_mutex_runtime="yes"
      ],
      [
        ac_cv_have_recursive_mutex_runtime="no"
      ],
      [
        AC_MSG_RESULT([cross-compiling: ])
      	ac_cv_have_recursive_mutex_runtime="no"
      ])
      LIBS=$lib_save
    ])
    
    AC_MSG_RESULT([$ac_cv_have_recursive_mutex_runtime])
    if test "$ac_cv_have_recursive_mutex_runtime" = "yes" ; then
      AC_HAVE_RECURSIVE_MUTEX_RUNTIME="define CGU_HAVE_RECURSIVE_MUTEX 1"
    else
      AC_HAVE_RECURSIVE_MUTEX_RUNTIME="undef CGU_HAVE_RECURSIVE_MUTEX"
    fi 
  else
    AC_HAVE_RECURSIVE_MUTEX_RUNTIME="undef CGU_HAVE_RECURSIVE_MUTEX"
  fi
  AC_SUBST(AC_HAVE_RECURSIVE_MUTEX_RUNTIME)
])

AC_DEFUN([AC_CHECK_TESTS_GTK2],
[
  PKG_CHECK_VERSION(tests, gtk+-2.0 >= 2.14.0,
  [
    COND_TESTS="tests"
  ],
  [
    COND_TESTS=""
  ])
  AC_SUBST(COND_TESTS)
])

AC_DEFUN([AC_CHECK_TESTS_GTK3],
[
  AC_MSG_CHECKING(for tests)
dnl GTK3 always succeeds
  AC_MSG_RESULT(yes)
  COND_TESTS="tests"
  AC_SUBST(COND_TESTS)
])
